
/**************************************************************************
**  (c) Copyright 2002, Andromeda Technology & Automation
** This is free software; you can redistribute it and/or modify it under the
** terms of the GNU General Public License, see the file COPYING.
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : access_cooker.h
**      SYSTEM NAME    : 
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      :  Cooks Apache http daemon access log lines
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Aug 11, 2003
**      LAST UPDATE     : Aug 11, 2003
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: access_cooker.h,v $
   Revision 1.1  2003-08-11 16:56:16  arjen
   Different kinds of log files are parsed by a collection of objects
   of different classes, derived from the base class line_cooker
   Depending on the message content or the message_type element in
   XML, one of these objects is selected.

   Logrunner is integrated with gcm_input. Although its functionality
   is still limited, a connection between logrunner and gcm_input
   is beginning to form.

*****************************/

/* static const char *RCSID = "$Id: access_cooker.h,v 1.1 2003-08-11 16:56:16 arjen Exp $"; */

#include "line_cooker.h"

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : access_cooker
//  BASECLASS      : 
//  MEMBERS        :
//  OPERATORS      :
//  METHODS        : 
//
//  DESCRIPTION    : 
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Aug 11, 2003
///////////////////////////////////////////////////////////////////////////
*/

class access_cooker : public line_cooker
{

protected:


public:

   access_cooker()
   {
   }

   bool check_pattern(String logline);
   bool cook_this(String logline, UTC arrival);

   String message_type()
   {
      return "apache access log";
   }

};
