
/**************************************************************************
**  (c) Copyright 2003, Andromeda Technology & Automation
** This is free software; you can redistribute it and/or modify it under the
** terms of the GNU General Public License, see the file COPYING.
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : message_filter.h
**      SYSTEM NAME    : 
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      :  
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Nov 26, 2003
**      LAST UPDATE     : Nov 26, 2003
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: message_filter.h,v $
   Revision 1.1  2003-12-04 10:38:09  arjen
   Major redesign. All input is handled through XML. Raw input data is first
   transformed into an XML document for further processing.
   A collection of polymorphic classes handle the transformation of various
   input formats into XML.
   Classifying input data is done with a finite improbability calculation.

*****************************/

/* static const char *RCSID = "$Id: message_filter.h,v 1.1 2003-12-04 10:38:09 arjen Exp $"; */

#ifndef MESSAGE_FILTER_H
#define MESSAGE_FILTER_H

#include <strstream>

#include <AXE/String.h>
#include <AXE/date.h>

#include "message_buffer.h"

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : message_filter
//  BASECLASS      : 
//  MEMBERS        :
//  OPERATORS      :
//  METHODS        : contruct_XML
//                   set_message_type
//
//  DESCRIPTION    : Transform any kind of input into an XML document
//                   for Gnucomo
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Nov 26, 2003
///////////////////////////////////////////////////////////////////////////
*/

class message_filter
{

protected:

   UTC    ts;     //    the timestamp.
   String hn;     //    the hostname
   String srv;    //    the service
   String mt;     //    the message type

   void scan_email_header(message_buffer &in);
   void construct_header(std::strstream &xml);

public:

   message_filter(String host, UTC arriv, String service)
   {
      hn  = host;
      ts  = arriv;
      srv = service;
   }

   virtual void construct_XML(message_buffer &in, std::strstream &xml);

   void set_message_type(String msgt)
   {
      mt = msgt;
   }
};

#endif // MESSAGE_FILTER_H
