<?php 

/**************************************************************************
**  (c) Copyright 2003, Andromeda Technology & Automation
** This is free software; you can redistribute it and/or modify it under the
** terms of the GNU General Public License, see the file COPYING.
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : services.php
**      SYSTEM NAME    : Gnucomo - Gnu Computer Monitoring
**      VERSION NUMBER : $Revision: 1.4 $
**
**  DESCRIPTION      :  Service Administration page.
**                      Input parameters: action (POST) : empty, 'Create'
**                              servcode (POST) : short name of the service to create or remove
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Aug 04, 2003
**      LAST UPDATE     : Aug 28, 2003
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: services.php,v $
   Revision 1.4  2007-11-21 14:38:06  arjen
   The buttonbar at the top of each page is now a fixed 'div' element
   instead of a framed page.
   Contributed by Edwin Nadorp.

   Revision 1.3  2007/10/19 07:16:44  arjen
   Improved interface for editing check patterns.

   Revision 1.2  2005/06/04 07:25:59  arjen
   Added an interface to edit check patterns

   Revision 1.1  2003/09/01 06:53:22  arjen
   New page to enter and modify services.

******************************/

// RCSID = "$Id: services.php,v 1.4 2007-11-21 14:38:06 arjen Exp $";

ini_set('include_path', '.:./classes:../phpclasses');

require_once('page.class.php');

function clientscripts()
{

?>

<script type='text/ecmascript'>

function CheckCreate(f)
{
   if (f.servcode.value == "")
   {
      alert("You must supply a service code");
      return false;
   }
   return true;
}

function CheckRemove(f)
{
   var message = "Are you sure you want to remove service ";
   message += f.servcode.value;
   message += " ?";

   return confirm(message);
}

</script>

<?php
}

class service_page extends page
{

   function Body()
   {

   clientscripts();

   if (isset($_POST['action']) && $_POST['action'] == 'Create' && !empty($_POST['servcode']))
   {
      pg_exec($this->database, "INSERT INTO service
                       (servicecode, servicename, default_priority, max_priority) VALUES ('"
                     . $_POST['servcode'] . "','" . $_POST['servname'] . "','"
                     . $_POST['defprior'] . "','" . $_POST['maxprior'] . "')");
   }

   if (isset($_POST['action']) && $_POST['action'] == 'Remove' && !empty($_POST['servcode']))
   {
      pg_exec($this->database, "DELETE FROM service WHERE servicecode='"
                                . $_POST['servcode'] . "'");
   }

   if (isset($_GET['servcode']))
   {
      echo "<script type='text/ecmascript'>
              document.getElementById('menu_title').innerHTML = 
               '<h1>Detailed Information for service " . $_GET['servcode'] . "<\/h1>'</script><br>";

      if (isset($_POST['action']) && $_POST['action'] == 'Save Changes')
      {
         $qry = "UPDATE service SET servicename='" . $_POST['servname'] . "'";
         $qry .= ", default_priority='" . $_POST['defprior'] . "'";
         $qry .= ", max_priority='" . $_POST['maxprior'] . "'";
         $qry .= " WHERE servicecode='" . $_GET['servcode'] . "'";

         pg_exec($this->database, $qry);
      }
      if (isset($_POST['action']) && $_POST['action'] == 'Add')
      {
         $qry = "INSERT INTO service_pattern VALUES ('". $_GET['servcode'] . "'";
         $qry .= ", '" . $_POST['Rank'] . "'";
         $qry .= ", '" . $_POST['Pattern'] . "'";
         $qry .= ", '" . $_POST['Pat_Action'] . "'";
         $qry .= ", '" . $_POST['Argument'] . "')";

         pg_exec($this->database, $qry);
      }
      if (isset($_POST['action']) && $_POST['action'] == 'Change')
      {
         $qry = "UPDATE service_pattern SET rank = '" . $_POST['Rank'] . "'";
         $qry .= ", pattern = '" . $_POST['Pattern'] . "'";
         $qry .= ", action = '" . $_POST['Pat_Action'] . "'";
         $qry .= ", argument = '" . $_POST['Argument'] . "'";
         $qry .= " WHERE service = '" . $_GET['servcode'] . "' AND rank = '" . $_POST['Rank'] . "'";

         pg_exec($this->database, $qry);
      }
      if (isset($_POST['action']) && $_POST['action'] == 'Delete')
      {
         $qry = "DELETE FROM service_pattern WHERE service = '". $_GET['servcode'] . "'";
         $qry .= " AND rank =  '" . $_POST['Rank'] . "'";

         pg_exec($this->database, $qry);
      }

      $res = pg_exec($this->database, "SELECT * FROM service
                                       WHERE servicecode='" . $_GET['servcode'] . "'");
      $srv = pg_fetch_object($res, 0);

      echo "<form action='services.php?servcode=" . $srv->servicecode . "' method='POST'>";
      echo "<table>";

      echo "<tr><td>Service name</td><td><input name='servname' type='text' value='";
      echo $srv->servicename . "'></td></tr>";
      echo "<tr><td>Default priority</td><td><select name='defprior'>";
      for ($prior = 1; $prior < 6; $prior++)
      {
         echo "<option value='$prior'";
         if ($prior == $srv->default_priority)
         {
            echo " SELECTED";
         }
         echo ">$prior</option>\n";
      }
      echo "</select>";
      echo "<tr><td>Maximum priority</td><td><select name='maxprior'>";
      for ($prior = 1; $prior < 6; $prior++)
      {
         echo "<option value='$prior'";
         if ($prior == $srv->max_priority)
         {
            echo " SELECTED";
         }
         echo ">$prior</option>\n";
      }
      echo "</select>";
      echo "</table>";
      echo "<input type='submit' name='action' value='Save Changes'>";
      echo "</form>";

      echo "<h1>Patterns to check logs of " . $srv->servicename . "</h1>\n";

      echo "<table>";
      echo "<tr><th>Rank</th><th>Pattern</th><th>Action</th>";
      echo "<th>Argument</th><th>&nbsp;</th><th>&nbsp;</th></tr>\n";

      $pat_res = pg_exec($this->database, "SELECT * FROM service_pattern
                                           WHERE service = '" . $srv->servicecode . "' ORDER BY rank");
      for ($pat_row = 0; $pat_row < pg_numrows($pat_res); $pat_row++)
      {
         $pat = pg_fetch_object($pat_res, $pat_row);
         echo "<tr><form action='services.php?servcode=" . $srv->servicecode . "' method='POST'><td>";
         echo "<input type='text' name='Rank' value='" . $pat->rank . "'>";
         echo "</td><td>";
         echo "<input type='text' size='80' name='Pattern' value='" . $pat->pattern . "'>";
         echo "</td><td>";
         //echo "<input type='text' name='Pat_Action' value='" . $pat->action . "'>";
         echo "<select name='Pat_Action'>";
         echo "   <option";
         if ($pat->action =='ignore') echo ' selected';
         echo ">ignore</option>";
         echo "   <option";
         if ($pat->action =='notify') echo ' selected';
         echo ">notify</option>";
         echo "   <option";
         if ($pat->action =='abuse') echo ' selected';
         echo ">abuse</option>";
         echo "   <option";
         if ($pat->action =='forgive') echo ' selected';
         echo ">forgive</option>";
         echo "</select>";
         echo "</td><td>";
         echo "<input type='text' name='Argument' value='" . $pat->argument . "'>";
         echo "</td><td>";
         echo "<input type='submit' name='action' value='Change'>";
         echo "</td><td>";
         echo "<input type='submit' name='action' value='Delete'>";
         echo "</td></form></tr>";
      }
      echo "<tr><form action='services.php?servcode=" . $srv->servicecode . "' method='POST'><td>";
      echo "<input type='text' name='Rank' value=''>";
      echo "</td><td>";
      echo "<input type='text' size='80' name='Pattern' value=''>";
      echo "</td><td>";
      //echo "<input type='text' name='Pat_Action' value=''>";
      echo "<select name='Pat_Action'>";
      echo "   <option selected>ignore</option>";
      echo "   <option>notify</option>";
      echo "   <option>abuse</option>";
      echo "   <option>forgive</option>";
      echo "</select>";
      echo "</td><td>";
      echo "<input type='text' name='Argument' value=''>";
      echo "</td><td>";
      echo "<input type='submit' name='action' value='Add'>";
      echo "</td><td>&nbsp;";
      echo "</td></form></tr>";
      echo "</table>";
   }
   else
   {
   echo "<script type='text/ecmascript'>document.getElementById('menu_title').innerHTML = '<h1>Service  Administration<\/h1>'</script><br>";

   $res = pg_exec($this->database, "SELECT * FROM service ORDER BY servicecode");

   echo "<table>";
   echo "<tr><th>Service code</th><th>Name</th><th>Priority</th><th>Max priority</th></tr>";
   $srv = 0;
   while ($srv < pg_numrows($res))
   {
      $u = pg_fetch_object($res, $srv);
      ?>
      <tr><td align='center'><a href='services.php?servcode=<?php echo $u->servicecode?>'><img src='service.png' alt='service'></a><br>
             <b><?php echo $u->servicecode ?></b>
      </td><td>
         <?php echo $u->servicename ?>
      </td><td>
         <?php echo $u->default_priority ?>
      </td><td>
         <?php echo $u->max_priority ?>
      </td><td>
          <form action='services.php' method='post' onSubmit='return CheckRemove(this)'>
              <input type='hidden' name='servcode' value='<?php echo $u->servicecode ?>'>
              <input type='submit' name='action' value='Remove'>
          </form>
      </td></tr>
      <?php
      $srv++;
   }
   echo "</table>";

?>

<h2>Create new service:</h2>

<form action='services.php' method='post' onSubmit='return CheckCreate(this)'>
Service code: <input name='servcode' type='text'>
Service name: <input name='servname' type='text'>
Default priority: <select name='defprior'>
<option value='1'>1</option>
<option value='2'>2</option>
<option value='3'>3</option>
<option value='4'>4</option>
<option value='5'>5</option>
</select>
Maximum priority: <select name='maxprior'>
<option value='1'>1</option>
<option value='2'>2</option>
<option value='3'>3</option>
<option value='4'>4</option>
<option value='5' SELECTED>5</option>
</select>
<br>
<input type='submit' name='action' value='Create'>
</form>

<?php
   }
   }
}

$page = new service_page("Gnucomo User Administration");

$page->Showpage();

?>
